Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.squawk.util
Interface Comparer

    public interface Comparer

A version of Java SE's java.util.Comparator interface.

A comparison function, which imposes a total ordering on some collection of objects. Comparers can be passed to a sort method (such as `Collections.sort`) to allow precise control over the sort order. Comparers can also be used to control the order of certain data structures (such as `TreeSet` or `TreeMap`).

The ordering imposed by a Comparer `c` on a set of elements `S` is said to be consistent with equals if and only if `(compare((Object)e1, (Object)e2)==0)` has the same boolean value as `e1.equals((Object)e2)` for every `e1` and `e2` in `S`.

Caution should be exercised when using a Comparer capable of imposing an ordering inconsistent with equals to order a sorted set (or sorted map). Suppose a sorted set (or sorted map) with an explicit Comparer `c` is used with elements (or keys) drawn from a set `S`. If the ordering imposed by `c` on `S` is inconsistent with equals, the sorted set (or sorted map) will behave "strangely." In particular the sorted set (or sorted map) will violate the general contract for set (or map), which is defined in terms of `equals`.

For example, if one adds two keys `a` and `b` such that `(a.equals((Object)b) && c.compare((Object)a, (Object)b) != 0)` to a sorted set with Comparer `c`, the second `add` operation will return false (and the size of the sorted set will not increase) because `a` and `b` are equivalent from the sorted set's perspective.

Note: It is generally a good idea for Comparers to implement `java.io.Serializable`, as they may be used as ordering methods in serializable data structures (like `TreeSet`, `TreeMap`). In order for the data structure to serialize successfully, the Comparer (if provided) must implement `Serializable`.

For the mathematically inclined, the relation that defines the total order that a given Comparer `c` imposes on a given set of objects `S` is:

           {(x, y) such that c.compare((Object)x, (Object)y) <= 0}.

The quotient for this total order is:

           {(x, y) such that c.compare((Object)x, (Object)y) == 0}.

It follows immediately from the contract for `compare` that the quotient is an equivalence relation on `S`, and that the natural ordering is a total order on `S`. When we say that the ordering imposed by `c` on `S` is consistent with equals, we mean that the quotient for the natural ordering is the equivalence relation defined by the objects' `equals(Object)` method(s):

           {(x, y) such that x.equals((Object)y)}.

See Also:
  `Arrays.sort(Object[], Comparer)`

Method Summary
`int` | `compare(Object o1, Object o2)` Compares its two arguments for order.

Method Detail

### compare

    int compare(Object o1,
                Object o2)

  Compares its two arguments for order. Returns a negative integer, zero, or a positive integer as the first argument is less than, equal to, or greater than the second.

  The implementor must ensure that `sgn(compare(x, y)) == -sgn(compare(y, x))` for all `x` and `y`. (This implies that `compare(x, y)` must throw an exception if and only if `compare(y, x)` throws an exception.)

  The implementor must also ensure that the relation is transitive: `((compare(x, y)>0) && (compare(y, z)>0))` implies `compare(x, z)>0`.

  Finally, the implementer must ensure that `compare(x, y)==0` implies that `sgn(compare(x, z))==sgn(compare(y, z))` for all `z`.

  It is generally the case, but not strictly required that `(compare(x, y)==0) == (x.equals(y))`. Generally speaking, any comparator that violates this condition should clearly indicate this fact. The recommended language is "Note: this comparator imposes orderings that are inconsistent with equals."

  Parameters:
    `o1` - the first object to be compared.
    `o2` - the second object to be compared.
  Returns:
    a negative integer, zero, or a positive integer as the first argument is less than, equal to, or greater than the second.
  Throws:
    `ClassCastException` - if the arguments' types prevent them from being compared by this Comparer.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

"
For updated information see the Java FRC site
"